package com.yice.webadmin.app.controller;

import com.github.pagehelper.page.PageMethod;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import com.yice.common.core.annotation.MyRequestBody;
import com.yice.common.core.constant.ErrorCodeEnum;
import com.yice.common.core.object.*;
import com.yice.common.core.util.MyCommonUtil;
import com.yice.common.core.util.MyModelUtil;
import com.yice.common.core.util.MyPageUtil;
import com.yice.common.log.annotation.OperationLog;
import com.yice.common.log.model.constant.SysOperationLogType;
import com.yice.webadmin.app.dto.ModelServiceDto;
import com.yice.webadmin.app.model.ModelService;
import com.yice.webadmin.app.service.ModelServiceService;
import com.yice.webadmin.app.vo.ModelServiceVo;
import io.swagger.annotations.Api;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * 模型服务管理操作控制器类。
 *
 * @author linking
 * @date 2023-04-13
 */
@Api(tags = "模型服务管理接口")
@Slf4j
@RestController
@RequestMapping("/admin/app/modelService")
public class ModelServiceController {

    @Autowired
    private ModelServiceService modelServiceService;

    /**
     * 新增知识图谱管理数据。
     *
     * @param modelServiceDto 新增对象。
     * @return 应答结果对象，包含新增对象主键Id。
     */
    @ApiOperationSupport(ignoreParameters = {"modelServiceDto.serviceId"})
    @OperationLog(type = SysOperationLogType.ADD)
    @PostMapping("/add")
    public ResponseResult<Long> add(@MyRequestBody ModelServiceDto modelServiceDto) {
        String errorMessage = MyCommonUtil.getModelValidationError(modelServiceDto, false);
        if (errorMessage != null) {
            return ResponseResult.error(ErrorCodeEnum.DATA_VALIDATED_FAILED, errorMessage);
        }
        ModelService modelService = MyModelUtil.copyTo(modelServiceDto, ModelService.class);
        modelService = modelServiceService.saveNew(modelService);
        return ResponseResult.success(modelService.getServiceId());
    }

    /**
     * 更新知识图谱管理数据。
     *
     * @param modelServiceDto 更新对象。
     * @return 应答结果对象。
     */
    @OperationLog(type = SysOperationLogType.UPDATE)
    @PostMapping("/update")
    public ResponseResult<Void> update(@MyRequestBody ModelServiceDto modelServiceDto) {
        String errorMessage = MyCommonUtil.getModelValidationError(modelServiceDto, true);
        if (errorMessage != null) {
            return ResponseResult.error(ErrorCodeEnum.DATA_VALIDATED_FAILED, errorMessage);
        }
        ModelService modelService = MyModelUtil.copyTo(modelServiceDto, ModelService.class);
        ModelService originalModelService = modelServiceService.getById(modelService.getServiceId());
        if (originalModelService == null) {
            // NOTE: 修改下面方括号中的话述
            errorMessage = "数据验证失败，当前 [数据] 并不存在，请刷新后重试！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        if (!modelServiceService.update(modelService, originalModelService)) {
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST);
        }
        return ResponseResult.success();
    }

    /**
     * 删除知识图谱管理数据。
     *
     * @param serviceId 删除对象主键Id。
     * @return 应答结果对象。
     */
    @OperationLog(type = SysOperationLogType.DELETE)
    @PostMapping("/delete")
    public ResponseResult<Void> delete(@MyRequestBody Long serviceId) {
        if (MyCommonUtil.existBlankArgument(serviceId)) {
            return ResponseResult.error(ErrorCodeEnum.ARGUMENT_NULL_EXIST);
        }
        return this.doDelete(serviceId);
    }

    /**
     * 批量删除知识图谱管理数据。
     *
     * @param serviceIdList 待删除对象的主键Id列表。
     * @return 应答结果对象。
     */
    @OperationLog(type = SysOperationLogType.DELETE_BATCH)
    @PostMapping("/deleteBatch")
    public ResponseResult<Void> deleteBatch(@MyRequestBody List<Long> serviceIdList) {
        if (MyCommonUtil.existBlankArgument(serviceIdList)) {
            return ResponseResult.error(ErrorCodeEnum.ARGUMENT_NULL_EXIST);
        }
        for (Long serviceId : serviceIdList) {
            ResponseResult<Void> responseResult = this.doDelete(serviceId);
            if (!responseResult.isSuccess()) {
                return responseResult;
            }
        }
        return ResponseResult.success();
    }

    /**
     * 列出符合过滤条件的知识图谱管理列表。
     *
     * @param modelServiceDtoFilter 过滤对象。
     * @param orderParam 排序参数。
     * @param pageParam 分页参数。
     * @return 应答结果对象，包含查询结果集。
     */
    @PostMapping("/list")
    public ResponseResult<MyPageData<ModelServiceVo>> list(
            @MyRequestBody ModelServiceDto modelServiceDtoFilter,
            @MyRequestBody MyOrderParam orderParam,
            @MyRequestBody MyPageParam pageParam) {
        if (pageParam != null) {
            PageMethod.startPage(pageParam.getPageNum(), pageParam.getPageSize());
        }
        ModelService modelServiceFilter = MyModelUtil.copyTo(modelServiceDtoFilter, ModelService.class);
        String orderBy = MyOrderParam.buildOrderBy(orderParam, ModelService.class);
        List<ModelService> modelServiceList =
                modelServiceService.getModelServiceListWithRelation(modelServiceFilter, orderBy);
        return ResponseResult.success(MyPageUtil.makeResponseData(modelServiceList, ModelService.INSTANCE));
    }

    /**
     * 查看指定知识图谱管理对象详情。
     *
     * @param serviceId 指定对象主键Id。
     * @return 应答结果对象，包含对象详情。
     */
    @GetMapping("/view")
    public ResponseResult<ModelServiceVo> view(@RequestParam Long serviceId) {
        ModelService modelService = modelServiceService.getByIdWithRelation(serviceId, MyRelationParam.full());
        if (modelService == null) {
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST);
        }
        ModelServiceVo modelServiceVo = MyModelUtil.copyTo(modelService, ModelServiceVo.class);
        return ResponseResult.success(modelServiceVo);
    }

    private ResponseResult<Void> doDelete(Long serviceId) {
        String errorMessage;
        // 验证关联Id的数据合法性
        ModelService originalModelService = modelServiceService.getById(serviceId);
        if (originalModelService == null) {
            // NOTE: 修改下面方括号中的话述
            errorMessage = "数据验证失败，当前 [对象] 并不存在，请刷新后重试！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        if (!modelServiceService.remove(serviceId)) {
            errorMessage = "数据操作失败，删除的对象不存在，请刷新后重试！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        return ResponseResult.success();
    }
}
